' -------------------------------------------------------------------------
'       From the book Inside Active Directory, ISBN 0-201-61621-1
'       Copyright (C) 2002 by Addison-Wesley
'       Script by Sakari Kouti (see http://www.kouti.com)
' You have a royalty-free right to use, modify, reproduce and distribute
' this script (and/or any modified version) in any way you find useful,
' provided that you agree that Addison-Wesley or Sakari Kouti has no
' warranty, obligations or liability for the script. If you modify
' the script, you must retain this copyright notice.
' -------------------------------------------------------------------------
Option Explicit

Const ERROR_NOT_CSCRIPT = 1		'wrong WSH environment
Const ERROR_NO_OPTIONS = 2		'wrong number of options or requested help
Const ERROR_COULDNT_ADD = 3
Const ERROR_COULDNT_DELETE = 4

Dim objArguments, intResult
Dim strObjectDN, strObjectRDN, strParentDN

Call CheckWSHEnvironment   'we want CScript and not WScript

Set objArguments = WScript.Arguments
If objArguments.Count < 1 Then Call ShowHelp

Select Case UCase(objArguments.Item(0))
    Case "?", "/?", "H", "/H", "HELP"
		Call ShowHelp
	Case "ADD"
		If objArguments.Count <> 3 Then ShowHelp
		strObjectRDN = objArguments.Item(1)
		strParentDN = objArguments.Item(2)
		intResult = AddObject(strObjectRDN, strParentDN)
	Case "DEL"
		If objArguments.Count <> 2 Then ShowHelp
		strObjectDN = objArguments.Item(1)
		intResult = DeleteObject(strObjectDN)
    Case Else
		Call ShowHelp
End Select
WScript.Quit(intResult)   'the program end

'==========================

Function AddObject(strObjectRDN, strParentDN)
	WScript.Echo "Object RDN: " & strObjectRDN
	WScript.Echo "Parent DN: " & strParentDN
	AddObject = 0  'and not ERROR_COULDNT_ADD
End Function

'==========================

Function DeleteObject(strObjectDN)
	WScript.Echo "Object DN: " & strObjectDN
	DeleteObject = 0  'and not ERROR_COULDNT_DELETE
End Function

'==========================

Sub CheckWSHEnvironment()
	Dim strScriptHostName

	strScriptHostName = WScript.FullName
	strScriptHostName = Right(strScriptHostName, Len(strScriptHostName) _
		- InStrRev(strScriptHostName,"\"))
	If UCase(strScriptHostName) <> "CSCRIPT.EXE" Then
		MsgBox "You should run this script in the CScript" & vbCrLf & _
			"command line environment. Either type CSCRIPT" & vbCrLf & _
			"before the script name or change CScript as" & vbCrLf & _
			"the default environment with the command" & vbCrLf & _
			"CSCRIPT //H:CSCRIPT", _
			vbOKOnly + vbCritical, "Error"
		WScript.Quit(ERROR_NOT_CSCRIPT)
	End If
End Sub

'==========================

Sub ShowHelp()
	WScript.Echo _
		vbCrLf & _
		"CmdTool.vbs - A Utility to Manage the World" & vbCrLf & _
		"by Sakari Kouti" & vbCrLf & _
		vbCrLf & _
		"Syntax:" & vbCrLf & _
		vbCrLf & _
		"CmdTool ADD objectRDN parentDN" & vbCrLf & _
		"    (Adds an object called objectRDN to parentDN)" & vbCrLf & _
		vbCrLf & _
		"CmdTool DEL objectDN" & vbCrLf & _
		"    (Deletes an object with objectDN)" & vbCrLf & _
		vbCrLf & _
		"Examples:" & vbCrLf & _
		vbCrLf & _
		"CmdTool ADD CN=Jack OU=Sales,DC=sanao,DC=com" & vbCrLf & _
		"CmdTool DEL CN=Jack,OU=Sales,DC=sanao,DC=com"
	WScript.Quit(ERROR_NO_OPTIONS)
End Sub
